#!/usr/bin/perl

$Identity = shift(); # the name of the file that holds the private auth key for ssh
$Inputfile = shift(); # the name of the archive that holds everything necessary to render the scripts
$Folder = shift(); # The folder that the script is run in.
$Number = shift(); # the number of pieces to break the anim up in to... This
# value is relative to the number of clients.. ie 2 = break up into 2xClients.
$Frames = shift(); # The number of frames in the animation


#Get a list of clients to use
#From the clients files.

open(IN,"clients");
$ClientsNumber = 0;
while(<IN>) {
	 chomp;
	 $Clients{$_}=0;
	 $ClientsNumber++;
}
close(IN);

#Number of frames per client = int($Frames/($ClientsNumber*$Number))
$Each = int($Frames/($ClientsNumber*$Number));
$Start = 1;

#Initial setup
while($Start<($Frames+1)) {
foreach $Client (keys %Clients) {
    if($Clients{$Client}==0) { # this client is free to use
     if($Start <($Frames+1)) {
	 print "Checking if $Client is available\n";
	 open(IN,"ping -nqc 1 $Client |");
	 $ok=0;
	  while(<IN>) {
		 if($_=~/, 0% packet loss/) {
			 $ok=1;
		 }
	  }
	 close(IN);
	 if($ok==1) {
		 print "Client $Client available\n";
	  } else {
		 print "Client $Client is not answering\n";
	 }

	  #Check to see if the the client has the datafile already.
	 if($ok==1) {
		 $Test = `ssh -i $Identity $Client ls $Client/$Inputfile`;
		 #print "Test = $Test\n";
		  if($Test eq "") {
			 print "We need send the datafile to the client\n";
			 system("ssh -i $Identity $Client mkdir $Client");
			 system("scp -i $Identity $Inputfile $Client:$Client");
			 system("ssh -i $Identity $Client \"cd $Client ; tar -zxf $Inputfile\"");
			 system("scp -i $Identity main.sh $Client:$Client/$Folder");
		 }
		 open(OUT,">$Client.sh");
		 $End = $Start+$Each-1;
		 if($End > $Frames) {
		 	$End = $Frames;
		 }
		 print OUT "ssh -i $Identity $Client $Client/$Folder/main.sh '$Client/$Folder ./xmegapov $Client t/ \"ship.ini +sf$Start +ef$End +v\"'";
		 print OUT "; scp -i $Identity $Client:$Client/$Folder/$Client.tgz .\n";
		 close(OUT);
		 system("chmod 700 $Client.sh");
		 print "Starting up a render on $Client to render frames $Start to $End\n";
		 system("screen -mds $Client ./$Client.sh");
		 print "Render started\n";
		 $Clients{$Client}=1;
 		 $Start=$End+1;
	 }
     }
    }
}



print "Checking to see if any of the clients have finished\n";
$Found=0;
while($Found == 0) {
    #	print "Starting the check\n";
	foreach $Client (keys %Clients) {
	    #		print "Checking client $Client - for file $Client.tgz\n";
#		<STDIN>;
		if(-e "$Client.tgz") {
			print "Client $Client has finished\n";
			$Found = 1;
			$Clients{$Client}=0;
		}
	}
	system(sleep 5);
}

#print "Someone has finished\n";

foreach $Client (keys %Clients) {
	if($Clients{$Client}==0 ) {
		print "Client $Client has finished. The client is free for another job\n";
		system("tar -zxf $Client.tgz");
		unlink("$Client.tgz");
	}
}
}

#Nothing left to do, so just have to wait for the final clients to finish and clean up
print "Clean up time\n";
$Lefttodo = 0;
while($Lefttodo == 0) {
    #Check if there are any clients left to wait for
    $Lefttodo = 1;
    foreach $Client (keys %Clients) {
	print "Client $Client status = $Clients{$Client}\n";
	if($Clients{$Client}==1) {
	
	    $Lefttodo = 0;
	}
    }
    if($Lefttodo ==1) {
	print "All finished\n";
	#Final clean up...
	foreach $Client (keys %Clients) {
	    system("ssh -i $Identity $Client \"rm -rf $Client/$Folder ; rm $Client/$Inputfile\"");
	    
	}
	exit 0;
    }
    #    print "Checking to see if any of the clients have finished\n";
    $Found=0;
    while($Found == 0) {
	# print "Starting the final check\n";
	    foreach $Client (keys %Clients) {
		if($Clients{$Client}==1) {
		    #	    print "Checking client $Client - for file $Client.tgz\n";
		    #<STDIN>;
		    if(-e "$Client.tgz") {
			    $Found = 1;
			    $Clients{$Client}=0;
		    }
		}
	    }
	    system(sleep 5);
    }
    
    #    print "Someone has finished\n";
    
    foreach $Client (keys %Clients) {
	if($Clients{$Client}==0 ) {
	    if(-e "$Client.tgz") {
		    print "Client $Client has finished.";
		    system("tar -zxf $Client.tgz");
		    unlink("$Client.tgz");
	    }
	}
    }
}
    
